package cmd

import (
	"fmt"
	"os"

	"github.com/spf13/cobra"
)

var rootCmd = &cobra.Command{
	Use:     "butane-jsonschema",
	Short:   "Generates JSONSchemas for a Butane Config Specification",
	Example: "butane-jsonschema gen --variant fcos --version 1.4.0",
}

func Execute() {
	genCmd.Flags().StringVarP(&variant, "variant", "", "", "Config variant")
	genCmd.Flags().StringVarP(&version, "version", "", "", "Variant version")
	genCmd.MarkFlagRequired("variant")
	genCmd.MarkFlagRequired("version")

	rootCmd.AddCommand(genCmd, variantsCmd)

	if err := rootCmd.Execute(); err != nil {
		fmt.Println(err)
		os.Exit(1)
	}
}
