package cmd

import (
	"fmt"

	"github.com/spf13/cobra"
	"gitlab.chromabits.com/etcinit/butane-jsonschema/config"
)

var variantsCmd = &cobra.Command{
	Use:   "variants",
	Short: "List available variants and their versions",
	Run: func(cmd *cobra.Command, args []string) {
		variantMap := config.GetVariantMap()

		for name, versions := range variantMap {
			fmt.Println(name)

			for version := range versions {
				fmt.Println("  ", version)
			}
		}
	},
}
