package config

import (
	fcos1_0 "github.com/coreos/butane/config/fcos/v1_0"
	fcos1_1 "github.com/coreos/butane/config/fcos/v1_1"
	fcos1_2 "github.com/coreos/butane/config/fcos/v1_2"
	fcos1_3 "github.com/coreos/butane/config/fcos/v1_3"
	fcos1_4 "github.com/coreos/butane/config/fcos/v1_4"
	fcos1_5_exp "github.com/coreos/butane/config/fcos/v1_5_exp"

	flatcar1_0 "github.com/coreos/butane/config/flatcar/v1_0"
	flatcar1_1_exp "github.com/coreos/butane/config/flatcar/v1_1_exp"

	openshift4_10 "github.com/coreos/butane/config/openshift/v4_10"
	openshift4_11 "github.com/coreos/butane/config/openshift/v4_11"
	openshift4_12_exp "github.com/coreos/butane/config/openshift/v4_12_exp"
	openshift4_8 "github.com/coreos/butane/config/openshift/v4_8"
	openshift4_9 "github.com/coreos/butane/config/openshift/v4_9"

	rhcos0_1 "github.com/coreos/butane/config/rhcos/v0_1"
)

type VariantMap = map[string]VariantVersionConfigMap
type VariantVersionConfigMap = map[string]interface{}

func GetVariantMap() VariantMap {
	variantMap := make(VariantMap)

	variantMap["fcos"] = make(VariantVersionConfigMap)
	variantMap["fcos"]["1.0.0"] = &fcos1_0.Config{}
	variantMap["fcos"]["1.1.0"] = &fcos1_1.Config{}
	variantMap["fcos"]["1.2.0"] = &fcos1_2.Config{}
	variantMap["fcos"]["1.3.0"] = &fcos1_3.Config{}
	variantMap["fcos"]["1.4.0"] = &fcos1_4.Config{}
	variantMap["fcos"]["1.5.0-experimental"] = &fcos1_5_exp.Config{}

	variantMap["flatcar"] = make(VariantVersionConfigMap)
	variantMap["flatcar"]["1.0.0"] = &flatcar1_0.Config{}
	variantMap["flatcar"]["1.1.0-experimental"] = &flatcar1_1_exp.Config{}

	variantMap["openshift"] = make(VariantVersionConfigMap)
	variantMap["openshift"]["4.8.0"] = &openshift4_8.Config{}
	variantMap["openshift"]["4.9.0"] = &openshift4_9.Config{}
	variantMap["openshift"]["4.10.0"] = &openshift4_10.Config{}
	variantMap["openshift"]["4.11.0"] = &openshift4_11.Config{}
	variantMap["openshift"]["4.12.0-experimental"] = &openshift4_12_exp.Config{}

	variantMap["rhcos"] = make(VariantVersionConfigMap)
	variantMap["rhcos"]["0.1.0"] = &rhcos0_1.Config{}

	return variantMap
}
